------------------------------------------------------------------------
-- The relations defined in Equality are equivalences
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.Equality
-- # import EqKind
-- # import TmVar

infixl 47 `transTm⁻`, `transTy⁻`, `transSubst⁻`

------------------------------------------------------------------------
-- Some congruences and related lemmas

abstract

  var⁻EqˢVarEq (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (v¹ : Γ¹ ∋ τ¹) (tv¹ : TmVar)
               (Γ² : Ctxt) (τ² : Ty Γ²) (v² : Γ² ∋ τ²) (tv² : TmVar)
    : Tm⁻Eq structural (var⁻ tv¹ v¹) (var⁻ tv² v²) -> v¹ ≈∋ v²
  var⁻EqˢVarEq (var⁻Cong eqv) = eqv

  castTm⁻Cong (k : EqKind)
              (tv¹ : TmVar) (Γ¹ : Ctxt) (τ₁¹, τ₂¹ : Ty Γ¹)
              (t₁¹ : Γ¹ ⊢ τ₁¹) (t₂¹ : Γ¹ ⊢ τ₂¹) (t⁻¹ : Tm⁻ tv¹ t₁¹)
              (tv² : TmVar) (Γ² : Ctxt) (τ₁², τ₂² : Ty Γ²)
              (t₁² : Γ² ⊢ τ₁²) (t₂² : Γ² ⊢ τ₂²) (t⁻² : Tm⁻ tv² t₁²)
    :  (eqt¹ : t₁¹ ≈⊢ t₂¹) -> (eqt² : t₁² ≈⊢ t₂²)
    -> Tm⁻Eq k t⁻¹ t⁻² -> Tm⁻Eq k (t⁻¹ ∷≡⊢⁻ eqt¹) (t⁻² ∷≡⊢⁻ eqt²)
  castTm⁻Cong eqt¹ eqt² eqt⁻ = castTm⁻Eqʳ eqt² $ castTm⁻Eqˡ eqt¹ eqt⁻

  castTy⁻Cong (Γ¹ : Ctxt) (τ₁¹, τ₂¹ : Ty Γ¹) (τ⁻¹ : Ty⁻ τ₁¹)
              (Γ² : Ctxt) (τ₁², τ₂² : Ty Γ²) (τ⁻² : Ty⁻ τ₁²)
    :  (eqτ¹ : τ₁¹ ≛ τ₂¹) -> (eqτ² : τ₁² ≛ τ₂²)
    -> τ⁻¹ ≛⁻ τ⁻² -> τ⁻¹ ∷≡✶⁻ eqτ¹ ≛⁻ τ⁻² ∷≡✶⁻ eqτ²
  castTy⁻Cong eqτ¹ eqτ² eqτ⁻ = castTy⁻Eqʳ eqτ² $ castTy⁻Eqˡ eqτ¹ eqτ⁻

  ∅⁻Cong (k : EqKind) (Δ¹, Δ² : Ctxt)
    :  (tv¹, tv² : TmVar) -> Δ¹ ≜ Δ²
    -> Subst⁻Eq k (∅⁻ tv¹ Δ¹) (∅⁻ tv² Δ²)
  ∅⁻Cong tv¹ tv² eqΔ =
    extEq⁻ εCong eqΔ (\_ v¹ _ v² eqv -> noVarInEmptyCtxt v¹)

  Cong▷⁻ (k : EqKind)
         (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
         (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
         (τ¹ : Ty Γ¹) (t¹ : Δ¹ ⊢ τ¹ / ρ¹) (t⁻¹ : Tm⁻ tv¹ t¹)
         (tv² : TmVar) (Γ², Δ² : Ctxt)
         (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
         (τ² : Ty Γ²) (t² : Δ² ⊢ τ² / ρ²) (t⁻² : Tm⁻ tv² t²)
    :  Subst⁻Eq k ρ⁻¹ ρ⁻² -> τ¹ ≛ τ² -> Tm⁻Eq k t⁻¹ t⁻²
    -> Subst⁻Eq k (ρ⁻¹ ▷⁻ t⁻¹) (ρ⁻² ▷⁻ t⁻²)
  Cong▷⁻ (extEq⁻ eqΓ₀ eqΔ₀ proof₀) eqτ₀ eqt⁻₀ =
    extEq⁻ (eqΓ₀ ▻Cong eqτ₀) eqΔ₀ (proof proof₀ eqt⁻₀)
    where
    proof (k : EqKind)
          (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
          (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
          (τ¹ : Ty Γ¹) (t¹ : Δ¹ ⊢ τ¹ / ρ¹) (t⁻¹ : Tm⁻ tv¹ t¹)
          (tv² : TmVar) (Γ², Δ² : Ctxt)
          (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
          (τ² : Ty Γ²) (t² : Δ² ⊢ τ² / ρ²) (t⁻² : Tm⁻ tv² t²)
      :  ExtEq⁻ k ρ⁻¹ ρ⁻² -> Tm⁻Eq k t⁻¹ t⁻²
      -> ExtEq⁻ k (ρ⁻¹ ▷⁻ t⁻¹) (ρ⁻² ▷⁻ t⁻²)
    proof proof' eqt⁻ _ (vz σ¹) _ (vz σ²) (vzCong eqσ) =
      castTm⁻Cong _ _ eqt⁻
    proof proof' eqt⁻ _ (vs v¹ σ¹) _ (vs v² σ²) (vsCong eqv eqσ) =
      castTm⁻Cong _ _ (proof' _ v¹ _ v² eqv)
    proof proof' eqt⁻ _ (v¹ ∷≡∋ eqτ) _ v² (castVarEqˡ eqτ eqv) =
      castTm⁻Eqˡ _ $ proof proof' eqt⁻ _ v¹ _ v² eqv
    proof proof' eqt⁻ _ v¹ _ (v² ∷≡∋ eqτ) (castVarEqʳ eqτ eqv) =
      castTm⁻Eqʳ _ $ proof proof' eqt⁻ _ v¹ _ v² eqv

  castSubst⁻Eqˡ (k : EqKind)
                (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
                (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
                (tv² : TmVar) (Γ², Δ² : Ctxt)
                (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
                (ρ³ : Subst Γ¹ Δ¹)
    :  (eqρ : ρ¹ ≘ ρ³) -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> Subst⁻Eq k (ρ⁻¹ ∷≡⇒⁻ eqρ) ρ⁻²
  castSubst⁻Eqˡ eqρ (extEq⁻ eqΓ eqΔ proof) =
    extEq⁻ eqΓ eqΔ (\_ _ _ _ eqv -> castTm⁻Eqˡ _ $ proof _ _ _ _ eqv)

  castSubst⁻Eqʳ (k : EqKind)
                (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
                (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
                (tv² : TmVar) (Γ², Δ² : Ctxt)
                (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
                (ρ³ : Subst Γ² Δ²)
    :  (eqρ : ρ² ≘ ρ³) -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> Subst⁻Eq k ρ⁻¹ (ρ⁻² ∷≡⇒⁻ eqρ)
  castSubst⁻Eqʳ eqρ (extEq⁻ eqΓ eqΔ proof) =
    extEq⁻ eqΓ eqΔ (\_ _ _ _ eqv -> castTm⁻Eqʳ _ $ proof _ _ _ _ eqv)

  castSubst⁻Cong (k : EqKind)
                 (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
                 (ρ₁¹, ρ₂¹ : Subst Γ¹ Δ¹) (ρ¹ : Subst⁻ tv¹ ρ₁¹)
                 (tv² : TmVar) (Γ², Δ² : Ctxt)
                 (ρ₁², ρ₂² : Subst Γ² Δ²) (ρ² : Subst⁻ tv² ρ₁²)
    :  (eqρ¹ : ρ₁¹ ≘ ρ₂¹) -> (eqρ² : ρ₁² ≘ ρ₂²)
    -> Subst⁻Eq k ρ¹ ρ² -> Subst⁻Eq k (ρ¹ ∷≡⇒⁻ eqρ¹) (ρ² ∷≡⇒⁻ eqρ²)
  castSubst⁻Cong eqρ¹ eqρ² eqρ⁻ =
    castSubst⁻Eqʳ eqρ² $ castSubst⁻Eqˡ eqρ¹ eqρ⁻

------------------------------------------------------------------------
-- Tm⁻Eq is an equivalence

abstract

  reflTm⁻ (k : EqKind) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
    : (t⁻ : Tm⁻ tv t) -> Tm⁻Eq k t⁻ t⁻
  reflTm⁻ (var⁻ _ v)   = var⁻Cong $ reflVar v
  reflTm⁻ (λ⁻ _ t)     = λ⁻Cong $ reflTm⁻ t
  reflTm⁻ (t₁ @⁻ t₂)   = app⁻Cong (reflTm⁻ t₁) (reflTm⁻ t₂)
  reflTm⁻ (t ∷≡⊢⁻ eqt) = castTm⁻Cong eqt eqt (reflTm⁻ t)

  symTm⁻ (k : EqKind)
         (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (tv¹ : TmVar)
         (t⁻¹ : Tm⁻ tv¹ t¹)
         (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (tv² : TmVar)
         (t⁻² : Tm⁻ tv² t²)
    : Tm⁻Eq k t⁻¹ t⁻² -> Tm⁻Eq k t⁻² t⁻¹
  symTm⁻ {βη}         = symTm⁻βη
  symTm⁻ {structural} = symTm⁻ˢ
    where
    symTm⁻ˢ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (tv¹ : TmVar)
            (t⁻¹ : Tm⁻ tv¹ t¹)
            (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (tv² : TmVar)
            (t⁻² : Tm⁻ tv² t²)
      : Tm⁻Eq structural t⁻¹ t⁻² -> Tm⁻Eq structural t⁻² t⁻¹
    symTm⁻ˢ (var⁻Cong eqv)        = var⁻Cong $ symVar eqv
    symTm⁻ˢ (λ⁻Cong eqt)          = λ⁻Cong $ symTm⁻ˢ eqt
    symTm⁻ˢ (app⁻Cong eqt₁ eqt₂)  = app⁻Cong (symTm⁻ˢ eqt₁) (symTm⁻ˢ eqt₂)
    symTm⁻ˢ (castTm⁻Eqˡ eqt eqt⁻) = castTm⁻Eqʳ eqt (symTm⁻ˢ eqt⁻)
    symTm⁻ˢ (castTm⁻Eqʳ eqt eqt⁻) = castTm⁻Eqˡ eqt (symTm⁻ˢ eqt⁻)

  transTm⁻ (k : EqKind)
           (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (tv¹ : TmVar)
           (t⁻¹ : Tm⁻ tv¹ t¹)
           (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (tv² : TmVar)
           (t⁻² : Tm⁻ tv² t²)
           (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³) (tv³ : TmVar)
           (t⁻³ : Tm⁻ tv³ t³)
    : Tm⁻Eq k t⁻¹ t⁻² -> Tm⁻Eq k t⁻² t⁻³ -> Tm⁻Eq k t⁻¹ t⁻³
  transTm⁻ {βη}         = transTm⁻βη
  transTm⁻ {structural} = transTm⁻ˢ
    where
    transTm⁻ˢ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (tv¹ : TmVar)
              (t⁻¹ : Tm⁻ tv¹ t¹)
              (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (tv² : TmVar)
              (t⁻² : Tm⁻ tv² t²)
              (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³) (tv³ : TmVar)
              (t⁻³ : Tm⁻ tv³ t³)
      :  Tm⁻Eq structural t⁻¹ t⁻² -> Tm⁻Eq structural t⁻² t⁻³
      -> Tm⁻Eq structural t⁻¹ t⁻³
    transTm⁻ˢ (var⁻Cong eqv¹²) (var⁻Cong eqv²³) =
      var⁻Cong (transVar eqv¹² eqv²³)
    transTm⁻ˢ (λ⁻Cong eqt¹²) (λ⁻Cong eqt²³) =
      λ⁻Cong (transTm⁻ˢ eqt¹² eqt²³)
    transTm⁻ˢ (app⁻Cong eqt₁¹² eqt₂¹²) (app⁻Cong eqt₁²³ eqt₂²³) =
      app⁻Cong (transTm⁻ˢ eqt₁¹² eqt₁²³) (transTm⁻ˢ eqt₂¹² eqt₂²³)
    transTm⁻ˢ (castTm⁻Eqˡ eqτ eqv¹) eqv² =
      castTm⁻Eqˡ eqτ (transTm⁻ˢ eqv¹ eqv²)
    transTm⁻ˢ eqv¹ (castTm⁻Eqʳ eqτ eqv²) =
      castTm⁻Eqʳ eqτ (transTm⁻ˢ eqv¹ eqv²)
    transTm⁻ˢ (castTm⁻Eqʳ eqτ eqv₁) (castTm⁻Eqˡ eqτ eqv₂) =
      transTm⁻ˢ eqv₁ eqv₂

------------------------------------------------------------------------
-- Ty⁻Eq is an equivalence

abstract

  reflTy⁻ (Γ : Ctxt) (τ : Ty Γ)
    : (τ⁻ : Ty⁻ τ) -> τ⁻ ≛⁻ τ⁻
  reflTy⁻ (✶⁻ Γ)        = ✶⁻Cong $ reflCtxt Γ
  reflTy⁻ (Π⁻ τ⁻₁ τ⁻₂)  = Π⁻Cong (reflTy⁻ τ⁻₁) (reflTy⁻ τ⁻₂)
  reflTy⁻ (El⁻ t⁻)      = El⁻Cong $ reflTm⁻ t⁻
  reflTy⁻ (τ⁻ ∷≡✶⁻ eqτ) = castTy⁻Cong eqτ eqτ (reflTy⁻ τ⁻)

  symTy⁻ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (τ⁻¹ : Ty⁻ τ¹)
         (Γ² : Ctxt) (τ² : Ty Γ²) (τ⁻² : Ty⁻ τ²)
    : τ⁻¹ ≛⁻ τ⁻² -> τ⁻² ≛⁻ τ⁻¹
  symTy⁻ (✶⁻Cong eqΓ)          = ✶⁻Cong $ symCtxt eqΓ
  symTy⁻ (Π⁻Cong eqτ⁻₁ eqτ⁻₂)  = Π⁻Cong (symTy⁻ eqτ⁻₁) (symTy⁻ eqτ⁻₂)
  symTy⁻ (El⁻Cong eqt⁻)        = El⁻Cong $ symTm⁻ eqt⁻
  symTy⁻ (castTy⁻Eqˡ eqτ eqτ⁻) = castTy⁻Eqʳ eqτ (symTy⁻ eqτ⁻)
  symTy⁻ (castTy⁻Eqʳ eqτ eqτ⁻) = castTy⁻Eqˡ eqτ (symTy⁻ eqτ⁻)

  transTy⁻ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (τ⁻¹ : Ty⁻ τ¹)
           (Γ² : Ctxt) (τ² : Ty Γ²) (τ⁻² : Ty⁻ τ²)
           (Γ³ : Ctxt) (τ³ : Ty Γ³) (τ⁻³ : Ty⁻ τ³)
    : τ⁻¹ ≛⁻ τ⁻² -> τ⁻² ≛⁻ τ⁻³ -> τ⁻¹ ≛⁻ τ⁻³
  transTy⁻ (✶⁻Cong eqΓ¹²) (✶⁻Cong eqΓ²³) =
    ✶⁻Cong (transCtxt eqΓ¹² eqΓ²³)
  transTy⁻ (Π⁻Cong eqτ⁻₁¹² eqτ⁻₂¹²) (Π⁻Cong eqτ⁻₁²³ eqτ⁻₂²³) =
    Π⁻Cong (transTy⁻ eqτ⁻₁¹² eqτ⁻₁²³) (transTy⁻ eqτ⁻₂¹² eqτ⁻₂²³)
  transTy⁻ (El⁻Cong eqt⁻¹²) (El⁻Cong eqt⁻²³) =
    El⁻Cong (transTm⁻ eqt⁻¹² eqt⁻²³)
  transTy⁻ (castTy⁻Eqˡ eqτ eqτ⁻¹) eqτ⁻² =
    castTy⁻Eqˡ eqτ (transTy⁻ eqτ⁻¹ eqτ⁻²)
  transTy⁻ eqτ⁻¹ (castTy⁻Eqʳ eqτ eqτ⁻²) =
    castTy⁻Eqʳ eqτ (transTy⁻ eqτ⁻¹ eqτ⁻²)
  transTy⁻ (castTy⁻Eqʳ eqτ eqτ⁻₁) (castTy⁻Eqˡ eqτ eqτ⁻₂) =
    transTy⁻ eqτ⁻₁ eqτ⁻₂

------------------------------------------------------------------------
-- Subst⁻Eq is an equivalence

  reflSubst⁻ (k : EqKind) (tv : TmVar) (Γ, Δ : Ctxt) (ρ : Subst Γ Δ)
    : (ρ⁻ : Subst⁻ tv ρ) -> Subst⁻Eq k ρ⁻ ρ⁻
  reflSubst⁻ (∅⁻ tv Δ) = ∅⁻Cong tv tv (reflCtxt Δ)
  reflSubst⁻ (ρ ▷⁻ t⁻) = Cong▷⁻ (reflSubst⁻ ρ) (reflTy _) (reflTm⁻ t⁻)
  reflSubst⁻ (ρ ∷≡⇒⁻ eqρ) = castSubst⁻Cong eqρ eqρ (reflSubst⁻ ρ)

  symSubst⁻ (k : EqKind)
            (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
            (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
            (tv² : TmVar) (Γ², Δ² : Ctxt)
            (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
    : Subst⁻Eq k ρ⁻¹ ρ⁻² -> Subst⁻Eq k ρ⁻² ρ⁻¹
  symSubst⁻ (extEq⁻ eqΓ eqΔ proof) =
    extEq⁻ (symCtxt eqΓ) (symCtxt eqΔ)
           (\_ _ _ _ eqv -> symTm⁻ (proof _ _ _ _ (symVar eqv)))

  transSubst⁻ (k : EqKind)
              (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
              (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
              (tv² : TmVar) (Γ², Δ² : Ctxt)
              (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
              (tv³ : TmVar) (Γ³, Δ³ : Ctxt)
              (ρ³ : Subst Γ³ Δ³) (ρ⁻³ : Subst⁻ tv³ ρ³)
    : Subst⁻Eq k ρ⁻¹ ρ⁻² -> Subst⁻Eq k ρ⁻² ρ⁻³ -> Subst⁻Eq k ρ⁻¹ ρ⁻³
  transSubst⁻ (extEq⁻ eqΓ¹² eqΔ¹² proof¹²)
              (extEq⁻ eqΓ²³ eqΔ²³ proof²³) =
    extEq⁻ (transCtxt eqΓ¹² eqΓ²³) (transCtxt eqΔ¹² eqΔ²³)
           (\_ v¹ _ v³ eqv¹³ ->
               let v²    = castVarCtxt v¹ eqΓ¹²
                   eqv¹² = castVarCtxtEq v¹ eqΓ¹²
                   eqv²³ = symVar eqv¹² `transVar` eqv¹³
               in
               proof¹² _ v¹ _ v² eqv¹²
                 `transTm⁻`
               proof²³ _ v² _ v³ eqv²³)

Implicit-Equivalence : Type
Implicit-Equivalence = time-plugin(Implicit-Equivalence, Set)
