------------------------------------------------------------------------
-- Substitution lemmas
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import Implicit.SubstitutionLemmas.IdVanishes
-- # import Implicit.SubstitutionLemmas.CompSplits
-- # import EqKind
-- # import TmVar

abstract

  wkSubVanishes⁻ (k : EqKind) (tv₂ : TmVar)
                 (Γ : Ctxt) (σ : Ty Γ) (t : Γ ⊢ σ)
    :  (tv₁ : TmVar) -> (t⁻ : Tm⁻ tv₂ t)
    -> Subst⁻Eq k (wk⁻ tv₁ σ ⊙⁻ sub⁻ t⁻) (id⁻ tv₁ Γ)
  wkSubVanishes⁻ _ t⁻ =
    extEq⁻⁼ (wk⁻ _ _ ⊙⁻ sub⁻ _) (id⁻ _ _) $ \_ v ->
      compSplitsVar⁻ v (wk⁻ _ _) (sub⁻ t⁻)
        `transTm⁻`
      substTm⁻Congˢ (substVar⁻Wk _ v _) (reflSubst⁻ _)
        `transTm⁻`
      subst⁻VsSub _ v t⁻
        `transTm⁻`
      symTm⁻ (idVanishesVar⁻ v)

  wkSubVanishesTm⁻ (k : EqKind) (tv₁, tv₂ : TmVar)
                   (Γ : Ctxt) (σ, τ : Ty Γ) (t : Γ ⊢ τ) (t' : Γ ⊢ σ)
    :  (t⁻ : Tm⁻ tv₁ t) -> (t⁻' : Tm⁻ tv₂ t')
    -> Tm⁻Eq k (t⁻ /⊢⁻ wk⁻ tv₁ σ /⊢⁻ sub⁻ t⁻') t⁻
  wkSubVanishesTm⁻ t⁻ t⁻' =
    symTm⁻ (compSplitsTm⁻ t⁻ (wk⁻ _ _) (sub⁻ t⁻'))
      `transTm⁻`
    substTm⁻Congˢ (reflTm⁻ t⁻) (wkSubVanishes⁻ _ t⁻')
      `transTm⁻`
    idVanishesTm⁻ _ t⁻

  sub⁻Commutes (k : EqKind) (tv₁, tv₂ : TmVar) (Γ, Δ : Ctxt) (σ : Ty Γ)
               (t : Γ ⊢ σ) (ρ : Subst Γ Δ)
    :  (t⁻ : Tm⁻ tv₁ t) -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> Subst⁻Eq k (sub⁻ t⁻ ⊙⁻ ρ⁻) ((ρ⁻ ↑⁻ σ) ⊙⁻ sub⁻ (t⁻ /⊢⁻ ρ⁻))
  sub⁻Commutes t⁻₀ ρ⁻₀ =
    extEq⁻⁼ (sub⁻ t⁻₀ ⊙⁻ ρ⁻₀) ((ρ⁻₀ ↑⁻ _) ⊙⁻ sub⁻ (t⁻₀ /⊢⁻ ρ⁻₀))
            (\_ v -> proof v t⁻₀ ρ⁻₀)
    where
    proof (tv₁, tv₂ : TmVar) (k : EqKind)
          (Γ, Δ : Ctxt) (σ : Ty Γ) (τ : Ty (Γ ▻ σ))
          (t : Γ ⊢ σ) (ρ : Subst Γ Δ)
      :  (v : Γ ▻ σ ∋ τ) -> (t⁻ : Tm⁻ tv₁ t) -> (ρ⁻ : Subst⁻ tv₂ ρ)
      -> Tm⁻Eq k (v /∋⁻ sub⁻ t⁻ ⊙⁻ ρ⁻)
                 (v /∋⁻ (ρ⁻ ↑⁻ σ) ⊙⁻ sub⁻ (t⁻ /⊢⁻ ρ⁻))
    proof (vz σ) t⁻ ρ⁻ =
      compSplitsVar⁻ (vz σ) (sub⁻ t⁻) ρ⁻
        `transTm⁻`
      substTm⁻Congˢ (substVar⁻VzSub t⁻) (reflSubst⁻ ρ⁻)
        `transTm⁻`
      symTm⁻ (substVar⁻VzSub (t⁻ /⊢⁻ ρ⁻))
        `transTm⁻`
      (symTm⁻ (Tm⁻⊔Eq _ _)
         `transTm⁻`
       symTm⁻ (substTm⁻Congˢ (substVar⁻VzLift σ ρ⁻)
                             (reflSubst⁻ (sub⁻ (t⁻ /⊢⁻ ρ⁻)))))
        `transTm⁻`
      symTm⁻ (compSplitsVar⁻ (vz σ) (ρ⁻ ↑⁻ σ) (sub⁻ (t⁻ /⊢⁻ ρ⁻)))
    proof {tv₁} (vs v σ) t⁻ ρ⁻ =
      compSplitsVar⁻ (vs v σ) (sub⁻ t⁻) ρ⁻
        `transTm⁻`
      substTm⁻Congˢ (substVar⁻VsSub _ v t⁻) (reflSubst⁻ ρ⁻)
        `transTm⁻`
      Tm⁻⊔Eq tv₁ _
        `transTm⁻`
      symTm⁻ (wkSubVanishesTm⁻ (v /∋⁻ ρ⁻) (t⁻ /⊢⁻ ρ⁻))
        `transTm⁻`
      symTm⁻ (substTm⁻Congˢ (substVar⁻VsLift v σ ρ⁻ _)
                            (reflSubst⁻ (sub⁻ (t⁻ /⊢⁻ ρ⁻))))
        `transTm⁻`
      symTm⁻ (compSplitsVar⁻ (vs v σ) (ρ⁻ ↑⁻ σ) (sub⁻ (t⁻ /⊢⁻ ρ⁻)))
    proof (v ∷≡∋ eqτ) t⁻ ρ⁻ =
      betweenTm⁻
        (substCastVar⁻ v eqτ (sub⁻ t⁻ ⊙⁻ ρ⁻))
        (substCastVar⁻ v eqτ ((ρ⁻ ↑⁻ _) ⊙⁻ sub⁻ (t⁻ /⊢⁻ ρ⁻))) $
          proof v t⁻ ρ⁻

  sub⁻CommutesTm⁻ (k : EqKind) (tv, tv₁, tv₂ : TmVar)
                  (Γ, Δ : Ctxt) (σ : Ty Γ) (τ : Ty (Γ ▻ σ))
                  (t : Γ ▻ σ ⊢ τ) (t' : Γ ⊢ σ) (ρ : Subst Γ Δ)
    :  (t⁻ : Tm⁻ tv t) -> (t⁻' : Tm⁻ tv₁ t') -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> Tm⁻Eq k (t⁻ /⊢⁻ sub⁻ t⁻' /⊢⁻ ρ⁻)
               (t⁻ /⊢⁻ ρ⁻ ↑⁻ σ /⊢⁻ sub⁻ (t⁻' /⊢⁻ ρ⁻))
  sub⁻CommutesTm⁻ t⁻ t⁻' ρ⁻ = coerceFromTm⁻ $
    symTm⁻ (compSplitsTm⁻ t⁻ (sub⁻ t⁻') ρ⁻)
      `transTm⁻`
    substTm⁻'Congˢ (weakCongˢ₁₂₁ _ _) (reflTm⁻ t⁻) (sub⁻Commutes t⁻' ρ⁻)
      `transTm⁻`
    compSplitsTm⁻ t⁻ (ρ⁻ ↑⁻ _) (sub⁻ $ t⁻' /⊢⁻ ρ⁻)

Implicit-SubstitutionLemmas-SubLemmas : Type
Implicit-SubstitutionLemmas-SubLemmas =
  time-plugin(Implicit-SubstitutionLemmas-SubLemmas, Set)
